//#include <c_ext.h>
#include "lcdt/charcode.h"

static unsigned char const dp3x12[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xE0, 0xE0, 0xE0 };

static const struct _ch10x12
  {
    unsigned char ch;
    unsigned char bm[24];
  }ch10x12[] =
{
  ' ',
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  '-',
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0xFF, 0xC0,
  0xFF, 0xC0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  '+',
  0,    0,
  0,    0,
  0x0C, 0,
  0x0C, 0,
  0x0C, 0,
  0xFF, 0xC0,
  0xFF, 0xC0,
  0x0C, 0,
  0x0C, 0,
  0x0C, 0,
  0,    0,
  0,    0,
  '.',
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0,    0,
  0x38, 0,
  0x38, 0,
  0x38, 0,
  '1',
  0x06, 0,
  0x0E, 0,
  0x1E, 0,
  0x36, 0,
  0x06, 0,
  0x06, 0,
  0x06, 0,
  0x06, 0,
  0x06, 0,
  0x06, 0,
  0x1F, 0x80,
  0x1F, 0x80,
  '2',
  0x3F, 0,
  0x7F, 0x80,
  0xE1, 0xC0,
  0xC0, 0xC0,
  0x01, 0xC0,
  0x03, 0x80,
  0x0F, 0,
  0x3C, 0,
  0x70, 0,
  0xE0, 0,
  0xFF, 0xC0,
  0xFF, 0xC0,
  '3',
  0xFF, 0xC0,
  0xFF, 0x80,
  0x03, 0,
  0x06, 0,
  0x0C, 0,
  0x0F, 0,
  0x03, 0x80,
  0x01, 0xC0,
  0xC0, 0xC0,
  0xE1, 0xC0,
  0x7F, 0x80,
  0x3F, 0,
  '4',
  0x07, 0,
  0x0F, 0,
  0x1F, 0,
  0x3B, 0,
  0x73, 0,
  0xE3, 0,
  0xC3, 0,
  0xFF, 0xC0,
  0xFF, 0xC0,
  0x03, 0,
  0x03, 0,
  0x03, 0,
  '5',
  0xFF, 0xC0,
  0xFF, 0xC0,
  0xC0, 0,
  0xC0, 0,
  0xFF, 0,
  0xFF, 0x80,
  0x01, 0xC0,
  0,    0xC0,
  0xC0, 0xC0,
  0xE1, 0xC0,
  0x7F, 0x80,
  0x3F, 0,
  '6',
  0x1F, 0,
  0x3F, 0,
  0x70, 0,
  0x60, 0,
  0xFF, 0,
  0xFF, 0x80,
  0xE1, 0xC0,
  0xC0, 0xC0,
  0xC0, 0xC0,
  0xE1, 0xC0,
  0x7F, 0x80,
  0x3F, 0,
  '7',
  0xFF, 0xC0,
  0xFF, 0xC0,
  0,    0xC0,
  0x01, 0xC0,
  0x03, 0x80,
  0x07, 0,
  0x0E, 0,
  0x1C, 0,
  0x18, 0,
  0x18, 0,
  0x18, 0,
  0x18, 0,
  '8',
  0x3F, 0,
  0x7F, 0x80,
  0xE1, 0xC0,
  0xC0, 0xC0,
  0xE1, 0xC0,
  0x7F, 0x80,
  0x7F, 0x80,
  0xE1, 0xC0,
  0xC0, 0xC0,
  0xE1, 0xC0,
  0x7F, 0x80,
  0x3F, 0,
  '9',
  0x3F, 0,
  0x7F, 0x80,
  0xE1, 0xC0,
  0xC0, 0xC0,
  0xC0, 0xC0,
  0xE1, 0xC0,
  0x7F, 0xC0,
  0x3F, 0xC0,
  0x01, 0x80,
  0x03, 0x80,
  0x3F, 0,
  0x3E, 0,
  '0',
  0x3F, 0,
  0x7F, 0x80,
  0xE1, 0xC0,
  0xC0, 0xC0,
  0xC0, 0xC0,
  0xC0, 0xC0,
  0xC0, 0xC0,
  0xC0, 0xC0,
  0xC0, 0xC0,
  0xE1, 0xC0,
  0x7F, 0x80,
  0x3F, 0,
  'O',
  0x3F, 0,
  0x7F, 0x80,
  0xE1, 0xC0,
  0xC0, 0xC0,
  0xC0, 0xC0,
  0xC0, 0xC0,
  0xC0, 0xC0,
  0xC0, 0xC0,
  0xC0, 0xC0,
  0xE1, 0xC0,
  0x7F, 0x80,
  0x3F, 0,
  'N',
  0xc0, 0xc0,
  0xe0, 0xc0,
  0xf0, 0xc0,
  0xd8, 0xc0,
  0xcc, 0xc0,
  0xc6, 0xc0,
  0xc3, 0xc0,
  0xc1, 0xc0,
  0xc0, 0xc0,
  0xc0, 0xc0,
  0xc0, 0xc0,
  0xc0, 0xc0,
  'F',
  0xff, 0xc0,
  0xff, 0xc0,
  0xc0, 0,
  0xc0, 0,
  0xc0, 0,
  0xfe, 0,
  0xfe, 0,
  0xc0, 0,
  0xc0, 0,
  0xc0, 0,
  0xc0, 0,
  0xc0, 0,
  '#',
  0x33, 0,
  0x33, 0,
  0x33, 0,
  0xff, 0xc0,
  0xff, 0xc0,
  0x33, 0,
  0x33, 0,
  0xff, 0xc0,
  0xff, 0xc0,
  0x33, 0,
  0x33, 0,
  0x33, 0
};


static unsigned char const swo [] =
{
  0,    0,    0,
  0,    0,    0xc0,
  0,    0x03, 0xc0,
  0,    0x0f, 0,
  0,    0x3c, 0,
  0x78, 0xf0, 0x1e,
  0xff, 0xc0, 0x3f,
  0xcf, 0,    0x33,
  0xcc, 0,    0x33,
  0xfc, 0,    0x3f,
  0x78, 0,    0x1e,
  0,    0,    0
};


static unsigned char const swc [] =
{
  0,    0,    0,
  0,    0,    0,
  0,    0,    0,
  0,    0,    0,
  0,    0,    0,
  0x78, 0,    0x1e,
  0xfc, 0,    0x3f,
  0xcf, 0xff, 0xf3,
  0xcf, 0xff, 0xf3,
  0xfc, 0,    0x3f,
  0x78, 0,    0x1e,
  0,    0,    0
};



unsigned char const * bm10x12 (unsigned char ch)
/**************************************************************/
/* return a pointer to bit matrix representing the character  */
/* ch into a font 10 x 12 pixel       						  */
/**************************************************************/
{
  unsigned char i;
  switch (ch)
    {
    case '.':
      return dp3x12; // decimal point
    case SW_OPEN:
      return swo;    /* simbolo switch aperto */
    case SW_CLOSED:
      return swc;    /* simbolo switch chiuso */
    default:
      i = sizeof(ch10x12) / sizeof(struct _ch10x12);
      while ((--i) && (ch10x12[i].ch != ch));
      return ch10x12[i].bm;
    }
}

