#include "types.h"
#include "LPC21xx.h"
#include "config.h"
/******************************************************************************
 *
 * Function Name: lowInit()
 *
 * Description:
 *    This function starts up the PLL then sets up the GPIO pins before
 *    waiting for the PLL to lock.  It finally engages the PLL and
 *    returns
 *
 * Calling Sequence:
 *    void
 *
 * Returns:
 *    void
 *
 *****************************************************************************/
void lowInit(void);//prototyoe
/****************************************************************************/
static void setpll(void)
{
  // set PLL multiplier & divisor.
  // values computed from config.h
  PLLCFG = PLLCFG_MSEL | PLLCFG_PSEL;

  // enable PLL
  PLLCON = PLLCON_PLLE;
  PLLFEED = 0xAA;                       // Make it happen.  These two updates
  PLLFEED = 0x55;                       // MUST occur in sequence.



  // wait for PLL lock
  while (!(PLLSTAT & PLLSTAT_LOCK))
    continue;

  // enable & connect PLL
  PLLCON = PLLCON_PLLE | PLLCON_PLLC;
  PLLFEED = 0xAA;                       // Make it happen.  These two updates
  PLLFEED = 0x55;                       // MUST occur in sequence.



}

void lowInit(void)
{
  setpll();

  // setup the parallel port pin
  IO0CLR = PIO0_ZERO_BITS;                // clear the ZEROs output
  IO0SET = PIO0_ONE_BITS;                 // set the ONEs output
  IO0DIR = PIO0_OUTPUT_BITS;              // set the output bit direction
  //IO0DIR = PIO0_INPUT_BITS;               // set the input bit direction

  IO1CLR = PIO1_ZERO_BITS;                // clear the ZEROs output
  IO1SET = PIO1_ONE_BITS;                 // set the ONEs output
  IO1DIR = PIO1_OUTPUT_BITS;              // set the output bit direction

  // setup & enable the MAM
  MAMTIM = MAMTIM_CYCLES;
  MAMCR = MAMCR_FULL;

  // set the peripheral bus speed
  // value computed from config.h
  VPBDIV = VPBDIV_VALUE;                // set the peripheral bus clock speed
}
